// files list support
PEditFile ef_create(bool m)
{
  PEditFile result;
  result=(PEditFile)malloc(sizeof(CEditFile));
  result->id = -1;
  result->main = m;
  result->next = result->prev = result;
  result->filename[0]=0;
  return result;
}

void ef_free(PEditFile value)
{
  PEditFile fl = value->next;
  if (value->main)
    while(fl != value){
      fl = fl->next;
      ef_free(fl->prev);
    };

  free(value);
}

PEditFile ef_getfile(int fid)
{
  PEditFile fl = editfiles->next;
  while(fl != editfiles){
    if (fl->id == fid) return fl;
    fl = fl->next;
  };
  return NULL;
}

PEditFile ef_addfile(int fid)
{
  PEditFile fl = editfiles->prev;
  fl->next = ef_create(false);
  fl->next->prev = fl;
  fl = fl->next;
  fl->next = editfiles;
  editfiles->prev = fl;
  fl->id = fid;
  return fl;
}

bool ef_deletefile(int fid)
{
  PEditFile fl = ef_getfile(fid);
  if (!fl) return false;
  fl->prev->next = fl->next;
  fl->next->prev = fl->prev;
  ef_free(fl);
  return true;
}

void OnLoad(void)
{
  editfiles=ef_create(true);
};

void OnExit(void)
{
  ef_free(editfiles);
};

PEditFile loadfile(int eid,char *filename)
{
  PEditFile fl;
  fl = ef_addfile(eid);
  if(fl) strcpy(fl->filename,filename);
  return fl;
};

// controls editor events
int OnEditorEvent(int event,void *param)
{
  EditorInfo ei;

  // close file
  if (event == EE_CLOSE)
  {
    ef_deletefile(*(int *)param);
    return 0;
  };
  if (event == EE_READ)
  {
//    char file[MAX_PATH],*filename;
    Info.EditorControl(ECTL_GETINFO,&ei);
    loadfile(ei.EditorID,ei.FileName);
/*    if(GetFullPathName(ei.FileName,sizeof(file),file,&filename))
      loadfile(ei.EditorID,file);
    else
      loadfile(ei.EditorID,ei.FileName);*/
  }
  return 0;
};

